import { ElementRef, EventEmitter, OnChanges } from '@angular/core';
import * as i0 from "@angular/core";
export declare class TwoWayPlotDirective implements OnChanges {
    private ele;
    /**
     *@description each elment is an object that represents a dot.
     */
    data: Object[];
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    correction: any;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    upType: any;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    sigThr: any;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    selectedItem: any;
    /**
     *@description When true the spots will emit their itemID, via nextStateFn Output when false it will not emit.
     */
    disableSelection: any;
    /**
     *@description The value will be used to label the x axis on the two way plot.
     */
    axisXLabel: any;
    /**
     *@description  The value will be used to label the y axis on the two way plot.
     */
    axisYLabel: any;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    numTicks: number;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    sigLabel: any;
    /**
     *@description This value matches the key on the data that deterimnes the spots name.
     */
    itemLabel: any;
    /**
     *@description This value will match the key on the data that determines the spots size from the data.
     */
    itemSize: string;
    /**
     *@description This value matches the key used to create the spotsId `${item}${itemId}`
     */
    itemId: any;
    /**
     *@description This value matches the key used to create the spotsId `${item}${itemId}`
     */
    item: any;
    /**
     *@description This function will triggered when clicking a spot if the disableSelection is true and it will emit the itemId of the spot that is clicked
     */
    nextStateFn: EventEmitter<{}>;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    itemScale: any;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    showXThreshold: any;
    /**
     *@description FIND OUT WHAT THIS IS AND DOCUMENT IT HERE
     */
    showYThreshold: any;
    private margin;
    private axisOffset;
    private mainComp;
    private tooltip;
    private svgExt;
    private svg;
    private width;
    private height;
    private x;
    private y;
    private color;
    /**
     * @description property  itemScale determines if pSize uses linear or log to determine axes
     */
    private pSize;
    private xAxis;
    private yAxis;
    private twoWayPlotVersion;
    constructor(ele: ElementRef);
    init(): void;
    ngOnChanges(changes: any): void;
    onResize(event: any): void;
    updateSelection(newID: any, oldID: any): void;
    updateData(data: any, correction: any, thr: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TwoWayPlotDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TwoWayPlotDirective, "[twoWayPlot]", never, { "data": "data"; "correction": "correction"; "upType": "upType"; "sigThr": "sigThr"; "selectedItem": "selectedItem"; "disableSelection": "disableSelection"; "axisXLabel": "axisXLabel"; "axisYLabel": "axisYLabel"; "numTicks": "numTicks"; "sigLabel": "sigLabel"; "itemLabel": "itemLabel"; "itemSize": "itemSize"; "itemId": "itemId"; "item": "item"; "itemScale": "itemScale"; "showXThreshold": "showXThreshold"; "showYThreshold": "showYThreshold"; }, { "nextStateFn": "nextStateFn"; }, never>;
}
